Assignments Assignments

Classes | Typedefs | Functions
Ray Namespace Reference

## Classes
class | AffineShape
class | Box
class | Camera
class | Cone
class | Cylinder
class | Difference
class | DirectionalLight
class | DynamicAffineShape
class | File
class | FileInstance
struct | GlobalProperties
class | GlobalSceneData
class | Intersection
class | KeyFrameData
class | KeyFrameEvaluator
class | KeyFrameFile
class | KeyFrameParameters
class | Light
class | LocalSceneData
class | Material
class | Mouse
class | PointLight
class | RayShapeIntersectionInfo
struct | RayTracingStats
class | Scene
class | SceneGeometry
class | Shader
class | Shape
struct | ShapeBoundingBox
class | ShapeBoundingBoxHit
class | ShapeList
class | Sphere
class | SphereLight
class | SpotLight
class | StaticAffineShape
class | Texture
class | Torus
class | Triangle
class | TriangleIndex
class | TriangleList
class | Union
class | Vertex
class | Window

## Typedefs
typedef KeyFrameData< Util::Matrix4D > | KeyFrameMatrices

## Functions
std::istream & | operator>> (std::istream &stream, Camera &camera)
std::ostream & | operator<< (std::ostream &stream, const Camera &camera)
template<typename DataType>
std::ostream & | operator<< (std::ostream &stream, const KeyFrameData< DataType > &keyFrameData)
template<typename DataType>
std::istream & | operator>> (std::istream &stream, KeyFrameData< DataType > &keyFrameData)
std::ostream & | operator<< (std::ostream &stream, const Light &light)
std::istream & | operator>> (std::istream &stream, Light &light)
string | ReadDirective (istream &stream)
void | UnreadDirective (istream &stream, const string &directive)
Shape * | ReadShape (std::istream &stream, const std::unordered_map< std::string, BaseFactory< Shape > * > &shapeFactories)
istream & | operator>> (istream &stream, Vertex &vertex)
ostream & | operator<< (ostream &stream, const Vertex &vertex)
ostream & | operator<< (ostream &stream, const GlobalSceneData &data)
istream & | operator>> (istream &stream, GlobalSceneData &data)
ostream & | operator<< (ostream &stream, const LocalSceneData &data)
istream & | operator>> (istream &stream, LocalSceneData &data)
istream & | operator>> (istream &stream, Material &material)
ostream & | operator<< (ostream &stream, const Material &material)
istream & | operator>> (istream &stream, Texture &texture)
ostream & | operator<< (ostream &stream, const Texture &texture)
istream & | operator>> (istream &stream, Shader &shader)
ostream & | operator<< (ostream &stream, const Shader &shader)
istream & | operator>> (istream &stream, File &file)
ostream & | operator<< (ostream &stream, const File &file)
istream & | operator>> (istream &stream, KeyFrameFile &keyFrameFile)
ostream & | operator<< (ostream &stream, const KeyFrameFile &keyFrameFile)
ostream & | operator<< (ostream &stream, const Scene &scene)
istream & | operator>> (istream &stream, Scene &scene)
std::string | ReadDirective (std::istream &stream)
void | UnreadDirective (std::istream &stream, const std::string &directive)
std::ostream & | operator<< (std::ostream &stream, const GlobalSceneData &data)
std::istream & | operator>> (std::istream &stream, GlobalSceneData &data)
std::ostream & | operator<< (std::ostream &stream, const LocalSceneData &data)
std::istream & | operator>> (std::istream &stream, LocalSceneData &data)
std::ostream & | operator<< (std::ostream &stream, const Scene &scene)
std::istream & | operator>> (std::istream &stream, Scene &scene)
std::ostream & | operator<< (std::ostream &stream, const File &file)
std::istream & | operator>> (std::istream &stream, File &file)
std::ostream & | operator<< (std::ostream &stream, const Vertex &vertex)
std::istream & | operator>> (std::istream &stream, Vertex &vertex)
std::ostream & | operator<< (std::ostream &stream, const Material &material)
std::istream & | operator>> (std::istream &stream, Material &material)
std::ostream & | operator<< (std::ostream &stream, const Texture &texture)
std::istream & | operator>> (std::istream &stream, Texture &texture)
std::ostream & | operator<< (std::ostream &stream, const Shader &shader)
std::istream & | operator>> (std::istream &stream, Shader &shader)
std::ostream & | operator<< (std::ostream &stream, const KeyFrameFile &keyFrameFile)
std::istream & | operator>> (std::istream &stream, KeyFrameFile &keyFrameFile)
std::ostream & | operator<< (std::ostream &stream, const Shape &shape)
std::istream & | operator>> (std::istream &stream, Shape &shape)

## Typedef Documentation

## ◆ KeyFrameMatrices

typedef KeyFrameData< Util::Matrix4D > Ray::KeyFrameMatrices

This class stores the key-frame transformation as 4x4 matrices

## Function Documentation

## ◆ operator<<() [1/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const File & | file )

## ◆ operator<<() [2/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const GlobalSceneData & | data )

## ◆ operator<<() [3/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const KeyFrameFile & | keyFrameFile )

## ◆ operator<<() [4/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const LocalSceneData & | data )

## ◆ operator<<() [5/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const Material & | material )

## ◆ operator<<() [6/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const Scene & | scene )

## ◆ operator<<() [7/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const Shader & | shader )

## ◆ operator<<() [8/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const Texture & | texture )

## ◆ operator<<() [9/22]

ostream & Ray::operator<< | ( | ostream & | stream,
|  | const Vertex & | vertex )

## ◆ operator<<() [10/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Camera & | camera )

This operator writes the camera out to a stream.

## ◆ operator<<() [11/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const File & | file )

This operator writes a File object out to a stream.

## ◆ operator<<() [12/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const GlobalSceneData & | data )

An operator for inserting the global data into a stream

## ◆ operator<<() [13/22]

template<typename DataType>

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const KeyFrameData< DataType > & | keyFrameData )

This operator writes the key-frame data out to a stream.

## ◆ operator<<() [14/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const KeyFrameFile & | keyFrameFile )

This operator writes out a KeyFrameFile object to a stream.

## ◆ operator<<() [15/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Light & | light )
| inline

This operator writes the Light out to a stream

## ◆ operator<<() [16/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const LocalSceneData & | data )

An operator for inserting the local data into a stream

## ◆ operator<<() [17/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Material & | material )

This operator writes out a Materieal object to a stream.

## ◆ operator<<() [18/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Scene & | scene )

This operator writes a Scene object out to a stream.

## ◆ operator<<() [19/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Shader & | shader )

This operator writes out a Shader object to a stream.

## ◆ operator<<() [20/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Shape & | shape )
| inline

This operator writes the shape out to a stream.

## ◆ operator<<() [21/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Texture & | texture )

This operator writes out a Texture object to a stream.

## ◆ operator<<() [22/22]

std::ostream & Ray::operator<< | ( | std::ostream & | stream,
|  | const Vertex & | vertex )

This operator writes a Vertex object out to a stream.

## ◆ operator>>() [1/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | File & | file )

## ◆ operator>>() [2/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | GlobalSceneData & | data )

## ◆ operator>>() [3/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | KeyFrameFile & | keyFrameFile )

## ◆ operator>>() [4/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | LocalSceneData & | data )

## ◆ operator>>() [5/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | Material & | material )

## ◆ operator>>() [6/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | Scene & | scene )

## ◆ operator>>() [7/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | Shader & | shader )

## ◆ operator>>() [8/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | Texture & | texture )

## ◆ operator>>() [9/22]

istream & Ray::operator>> | ( | istream & | stream,
|  | Vertex & | vertex )

## ◆ operator>>() [10/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Camera & | camera )

This operator reads the camera in from a stream.

## ◆ operator>>() [11/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | File & | file )

This operator reads in a File object from a stream.

## ◆ operator>>() [12/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | GlobalSceneData & | data )

An operator for extracting the global data from a stream

## ◆ operator>>() [13/22]

template<typename DataType>

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | KeyFrameData< DataType > & | keyFrameData )

This operator reads the key-frame data in from a stream.

## ◆ operator>>() [14/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | KeyFrameFile & | keyFrameFile )

This operator reads in a KeyFrameFile object from a stream.

## ◆ operator>>() [15/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Light & | light )
| inline

This operator reads the Light in from a stream

## ◆ operator>>() [16/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | LocalSceneData & | data )

An operator for extracting the local data from a stream

## ◆ operator>>() [17/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Material & | material )

This operator reads in a Materieal object from a stream.

## ◆ operator>>() [18/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Scene & | scene )

This operator reads in a Scene object from a stream.

## ◆ operator>>() [19/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Shader & | shader )

This operator reads in a Shader object from a stream.

## ◆ operator>>() [20/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Shape & | shape )
| inline

This operator reads a shape from a stream.

## ◆ operator>>() [21/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Texture & | texture )

This operator reads in a Texture object from a stream.

## ◆ operator>>() [22/22]

std::istream & Ray::operator>> | ( | std::istream & | stream,
|  | Vertex & | vertex )

This operator reads in a Vertex object from a stream.

## ◆ ReadDirective() [1/2]

string Ray::ReadDirective | ( | istream & | stream | ) |

## ◆ ReadDirective() [2/2]

std::string Ray::ReadDirective | ( | std::istream & | stream | ) |

This function tries to read the next directive from a stream.

## ◆ ReadShape()

Shape * Ray::ReadShape | ( | std::istream & | stream,
|  | const std::unordered_map< std::string, Util::BaseFactory< Shape > * > & | shapeFactories )

This function tries to read the next shape in from a stream, using the specified shape factories to resolve directive with objects.

## ◆ UnreadDirective() [1/2]

void Ray::UnreadDirective | ( | istream & | stream,
|  | const string & | directive )

## ◆ UnreadDirective() [2/2]

void Ray::UnreadDirective | ( | std::istream & | stream,
|  | const std::string & | directive )

This function puts the directive back into the stream.